package faketango;

import java.net.*;
import java.io.*;
import java.applet.Applet;
import consts.*;
import messages.*;
import java.util.*;

public abstract class FakeAppletBase extends Applet implements FakeAppletBaseInterface{

    Socket s;
    DataInputStream dis;
    DataOutputStream dos;
    Listener l;
    String username="Jozef";
  String ismaster;

    public void register() {
        int port;
        try {
            String po=getParameter("port");
            port=Integer.parseInt(po);
        }
        catch(Exception e) {port=5678;}
        username=getParameter("username");
	ismaster=getParameter("master");
        if (username==null)
            username="Jozef";
	if(ismaster==null)
	  ismaster="true";
        try {
            s=new Socket(getCodeBase().getHost(),port);
            dis=new DataInputStream(s.getInputStream());
            dos=new DataOutputStream(s.getOutputStream());
            l=new Listener(this);
            l.start();
        }
        catch (Exception e) {
            e.printStackTrace();
            destroy();
        }
    }

    public void send(AppEventMessage em) {
        if (em.getType()==Const.CONTROL)
	  receive(new MyMsg(this,em.getData()[0]));
        else {
            try {
                int i=em.getLen();
                byte[] b=em.getData();
                dos.writeInt(i);
                dos.write(b);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    public abstract synchronized void receive(AppEventMessage em);

    public void destroy() {
        try {
            s.close();
            l.stop();
        }
        catch (Exception e) {}
        super.destroy();
    }
  public DataInputStream getDIS()
    {
      return dis;
    }
}








