package tango;
import messages.*;
import consts.*;
import java.util.*;

public class Semo
{
  CAppRequestEventMessage msg;
  TNode tn;
  byte code;
  boolean waiting;
  boolean response_available;
  public Semo(TNode tn,byte code)
    {
      this.code=code;
      this.tn=tn;
      byte b[]=new byte[1];
      b[0]=code;
      msg=new CAppRequestEventMessage(b);
      waiting=false;
      response_available=false;
    }
  
  CAppAnswerEventMessage res;
  public synchronized void response(CAppAnswerEventMessage res)
    {
      this.res=res;
      response_available=true;
      notifyAll();
    }
  public CAppAnswerEventMessage request()
    {
      synchronized(this)
	{
	  waiting=true;
	  response_available=false;
	}
      tn.abi.send(msg);
      synchronized(this)
	{
	  try
	    {
	      while(response_available==false || res==null)
		wait();
	    }
	  catch(Exception e)
	    {
	    }
	  waiting=false;
	}
      return res;
    }
  public synchronized boolean check()
    {
      return waiting;
    }
}
